#include <windows.h>
#include <stdio.h>
#include <commctrl.h>
#include "mydll.h"

HINSTANCE MyModuleHandle = 0;
HHOOK Hook = 0;
HWND MyWnd = 0;
FILE *LogFile = 0;

BOOL WINAPI DllMain(HINSTANCE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
   switch (ul_reason_for_call)
   {
   case DLL_PROCESS_ATTACH:
   case DLL_THREAD_ATTACH:
   case DLL_THREAD_DETACH:
   case DLL_PROCESS_DETACH:
      MyModuleHandle = hModule;
      break;
   }
   return TRUE;
}

BOOL CALLBACK EnumChildProc(HWND hwnd, LPARAM)
{
   MyWnd = hwnd;
   return FALSE;
}

LRESULT CALLBACK CallWndProc(int nCode, WPARAM wParam, LPARAM lParam)
{
   if(!MyWnd)
   {
      MyWnd = FindWindow(0, "ProcessMonitor");
      if(MyWnd)
      {
         EnumChildWindows(MyWnd, EnumChildProc, 0);
      }
   }
   CWPSTRUCT* CwStruct = (CWPSTRUCT* )lParam;
   if(MyWnd && CwStruct->hwnd == MyWnd)
   {
      if(!LogFile)
      {
         LogFile = fopen("c:\\log.txt", "wt");
      }
      if(CwStruct->message == LVM_INSERTITEM && CwStruct->wParam == 0)
      {
         LVITEM *lvc = (LVITEM *)CwStruct->lParam;
         if(LogFile)
         {
            fprintf(LogFile, "The Msg: %d - %s\n", CwStruct->message, lvc->pszText);
         }
      }
   }

   return CallNextHookEx(Hook, nCode, wParam, lParam);
}


int InstallHook()
{
   if(Hook)
      return false;
   Hook = SetWindowsHookEx(WH_CALLWNDPROC, (HOOKPROC  )CallWndProc, MyModuleHandle, 0);

   return Hook != 0 ? 0 : GetLastError();
}

void UnInstallHook()
{
   if(Hook)
      UnhookWindowsHookEx(Hook);
   Hook = 0;
}
